% ----------------------------------------------------------------------
%  MAIN PROGRAM - generated by the Rappture Builder
% ----------------------------------------------------------------------

% open the XML file containing the run parameters
% the file name comes in from the command-line via variable 'infile'
io = rpLib(infile);
global R0 A1 A2 Ap Kv Av Ts pc lmax l;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get input values from Rappture
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% get input value for input.group(introduction).note(intro)
intro = rpLibGetString(io,'input.phase(introduction).note(intro).current');

% get input value for input.group(value2).note(vial)
vial = rpLibGetString(io,'input.phase(value2).note(vial).current');

% get input value for input.group(resenv).note(vial2)
vial2 = rpLibGetString(io,'input.phase(resenv).note(vial2).current');

% get input value for input.group(value2).group(geom).number(Ap)
Ap = rpLibGetDouble(io,'input.phase(value2).group(geom).number(Ap).current');

% get input value for input.group(value2).group(geom).number(Av)
Av = rpLibGetDouble(io,'input.phase(value2).group(geom).number(Av).current');

% get input value for input.group(value2).group(geom).number(V)
Vfill = rpLibGetDouble(io,'input.phase(value2).group(geom).number(V).current');

% get input value for input.group(value2).group(geom).number(c)
c = rpLibGetDouble(io,'input.phase(resenv).group(resist).number(c).current');

% get input value for input.group(value2).group(geom).number(Kv)
Kv = rpLibGetDouble(io,'input.phase(value2).group(geom).number(Kv).current');

% get input value for input.group(resenv).group(resist).number(R0)
R0 = rpLibGetDouble(io,'input.phase(resenv).group(resist).number(R0).current');

% get input value for input.group(resenv).group(resist).number(A1)
A1 = rpLibGetDouble(io,'input.phase(resenv).group(resist).number(A1).current');

% get input value for input.group(resenv).group(resist).number(A2)
A2 = rpLibGetDouble(io,'input.phase(resenv).group(resist).number(A2).current');

% get input value for input.group(resenv).group(env).number(Pch)
pc = rpLibGetDouble(io,'input.phase(resenv).group(env).number(Pch).current');

% get input value for input.group(resenv).group(env).number(Tsh)
Ts = rpLibGetDouble(io,'input.phase(resenv).group(env).number(Tsh).current');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Add your code here for the main body of your program
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pc=pc*10^(-3);
T=Ts; 
hours=0;          
lmax=lmax_FUN(Vfill,Ap,c);
dmw=dm_water(c,Vfill);
dm=dmw/10;
options=optimset('Display','iter'); 
for n=0:10,
    l=n/10*lmax;
    x0=T;
    [T,goal] = fsolve(@lyo,x0,options)
    R=R_FUN(R0,A1,A2,l);
    p0=p0_FUN(T);
    sr=sublimation_rate(Ap,p0,pc,R);
    DT=DT_FUN(lmax,l,p0,pc,R,Ts,T);
    
    t=T-273.16;
    t_b=t+DT;
    if n==0,
        t_dry=0;
    else
        t_dry=dm/sr;
    end
    hours=t_dry+hours;
    row(n+1,:)=[n;l/lmax*100;R;T;p0;goal;sr;DT;t_dry;t;t_b;hours];
end
pcent_l=(row(:,2)).';
hours=(row(:,12)).';
Temp=(row(:,11)).';
p=(row(:,5)).';
sub=(row(:,7)).';


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Save output values back to Rappture
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% save output value for output.curve(temperature)
% this assumes a vector 'x' and a vector 'y'
xydata = [hours;Temp];
str = sprintf('%12g %12g\n', xydata);
rpLibPutString(io,'output.curve(temperature).component.xy',str,0);

% save output value for output.curve(pressure)
% this assumes a vector 'x' and a vector 'y'
xydata = [hours;p*10^3];
str = sprintf('%12g %12g\n', xydata);
rpLibPutString(io,'output.curve(pressure).component.xy',str,0);

% save output value for output.curve(subrate)
% this assumes a vector 'x' and a vector 'y'
xydata = [hours;sub];
str = sprintf('%12g %12g\n', xydata);
rpLibPutString(io,'output.curve(subrate).component.xy',str,0);

% save output value for output.curve(percent)
% this assumes a vector 'x' and a vector 'y'
xydata = [hours;pcent_l];
str = sprintf('%12g %12g\n', xydata);
rpLibPutString(io,'output.curve(percent).component.xy',str,0);


rpLibResult(io);
quit;
